<?php


namespace App\Models;


use App\Entities\RespostaNumericaInteira\RespostaNumericaInteira;
use App\Utils\Collections\GeneralCollection;

class RespostaNumericaInteiraModel extends ModelEntity
{
    protected $table = 'resposta_numerica_inteira';
    protected $primaryKey = 'id';
    protected $returnType = 'array';
    protected $allowedFields = [
        'id_resposta_formulario',
        'resposta',
    ];
    protected $useSoftDeletes = false;
    protected $skipValidation = true;
    protected $useTimestamps = false;


    public function registerRespostaNumericaInteiraCollection (GeneralCollection $resposta_numerica_inteira_collection): bool {
        if ($resposta_numerica_inteira_collection->length === 0) {
            return true;
        }
        $sql = 'insert into resposta_numerica_inteira (
                    `id_resposta_formulario`,
                    `resposta`
                ) values ();
        ';
        $values = $resposta_numerica_inteira_collection->map(function (RespostaNumericaInteira $resposta_numerica_inteira) : string {
            return "(
                {$resposta_numerica_inteira->getIdRESPOSTAFORMULARIO()},   
                {$resposta_numerica_inteira->getResposta()}   
            )";
        })->join(',');
        $sql = str_replace('values ()', "values $values;", $sql);
        $query = $this->db->query($sql);
        return $query->connID->affected_rows === $resposta_numerica_inteira_collection->length;
    }

    public function updateRespostaNumericaInteiraCollection (RespostaNumericaInteira $resposta_numerica_inteira_collection, int $id_resposta_formulario): bool {
        $data = $resposta_numerica_inteira_collection->toArray(true);
        if (count($data) > 0) {
            $binds = ['id_resposta_formulario' => $id_resposta_formulario];
            $sql = "
                update resposta_numerica_inteira
            ";
            $sql .= $this->generateUpdateSets($data, $binds);
            $sql .= 'where resposta_numerica_inteira.id_resposta_formulario = :id_resposta_formulario:';
            $query = $this->db->query($sql, $binds);
            $errors = $this->errors();
            return !$errors;
        } else {
            return true;
        }
    }

    public function updateResposta (array $data, int $id_resposta_formulario): bool {
//        $data = $resposta_numerica_inteira_collection->toArray(true);
        if (count($data) > 0) {
            $binds = ['id_resposta_formulario' => $id_resposta_formulario];
            $sql = "
                update resposta_numerica_inteira
            ";
            $sql .= $this->generateUpdateSets($data, $binds);
            $sql .= 'where resposta_numerica_inteira.id_resposta_formulario = :id_resposta_formulario:';
            $query = $this->db->query($sql, $binds);
            $errors = $this->errors();
            return !$errors;
        } else {
            return true;
        }
    }
}
